import java.util.Properties;


public class CrowdingGA_withMirrorDistance extends CrowdingGA {
	
	CrowdingGA_withMirrorDistance(Properties props, Landscape lscape, int rand_seed){
		super(props, lscape, rand_seed);
		ea_type = "CrowdingGA_withMirrorDistance";
	}
	
	
	int nearestNeighborInt(Genome target, Individual[] indivArray){
		int NN = 0;
		double minDistance = target.mirrorDistance(indivArray[0].genome);
		for(int i=1; i<indivArray.length; i++){
			double temp = target.mirrorDistance(indivArray[i].genome);
			if(temp<minDistance){
				minDistance = temp; 
				NN=i;
			}
		}
		return NN;
	}
	
	@Override
	int nearestNeighborInt(Genome target, Individual[] indivArray, int crowdingFactor){
		
		if(crowdingFactor>indivArray.length){
			System.err.println("Ricky: crowdingFactor>indivArray.length");
			System.exit(-1);
		}
		
		/*****************************************/
		// Prepare the candidate individual index
		/*****************************************/
		int candidateIndex[] = generateCandidateIndex(indivArray,crowdingFactor);
		
		/*************************************************/
		// Choose the closest candidate individual index
		/*************************************************/
		int NN = 0;
		float minDistance = target.mirrorDistance(indivArray[candidateIndex[0]].genome);
		for(int i=1; i<candidateIndex.length; i++){
			float temp = target.mirrorDistance(indivArray[candidateIndex[i]].genome);
			if(temp<minDistance){
				minDistance = temp; 
				NN=candidateIndex[i];
			}
		}
		return NN;
	}
	
	
	
	
}
