import java.lang.reflect.Constructor;
import java.util.StringTokenizer;


public class TestingRelativeEncodingClass {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

//		StringBuffer seq = new StringBuffer("pphhhphhhhhhhhppphhhhhhhhhhphppphhhhhhhhhhhhpppphhhhhhphhphp");
//		char LMrelativeEncoding[] = "FRDLUFRUFDDLFDRFFRDUDDFUFUUFRLFLLDUFRRFDFFDLLUDULDFURULURF".toCharArray();
		
		StringBuffer seq = new StringBuffer("hphpphhphpphphhpphph");
		char LMrelativeEncoding[] = "FFFFFFFFRLFFFFFFFF".toCharArray();
		
//		LMrelativeEncoding = createMirror(LMrelativeEncoding);
		                          
		int result[][] = convertToCoordinates(LMrelativeEncoding);
		System.out.print("aa=[");
		for(int i=0; i<result.length; i++){
			for(int j=0; j<result[i].length; j++){
				System.out.print(result[i][j]+" ");
			}
			System.out.print(";");
		}
		System.out.print("];\n");
		
		System.out.print("bb=[");
		for(int i=0; i<seq.length(); i++){
			if(seq.charAt(i)=='h'){
				System.out.print("1;");
			}else{
				System.out.print("0;");
			}
		}
		System.out.print("];\n");
		
		
		 

	}
	
public static char[] createMirror(char[] gene){
		
		char[] newGene = new char[gene.length];
		for(int i=0; i<gene.length; i++){
			switch(gene[i]){
				case 'F':
					newGene[i] = 'F';
					break;
				case 'R':
					newGene[i] = 'L';
					break;
				case 'L':
					newGene[i] = 'R';
					break;
				case 'U':
					newGene[i] = 'D';
					break;
				case 'D':
					newGene[i] = 'U';
					break;
				default:
					System.err.println("not FRLUD");
					System.exit(-1);
			}
		}
		
		return newGene;
	}
	
	public static int[][] convertToCoordinates(char[] LMrelativeEncoding){
		int points[][] = new int[LMrelativeEncoding.length+2][3];
		points[0][0] = 0; points[0][1] = 0; points[0][2] = 0;	//xyz
		points[1][0] = 1; points[1][1] = 0; points[1][2] = 0;
		for(int i=0; i<LMrelativeEncoding.length; i++){
			
			int deltaX = points[i+1][0]-points[i][0];
			int deltaY = points[i+1][1]-points[i][1];
			int deltaZ = points[i+1][2]-points[i][2];
			
			//checking
			if((deltaX+deltaY+deltaZ)!=1 && (deltaX+deltaY+deltaZ)!=-1){
				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
				System.exit(-1);
			}
			
			if(deltaX==1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaX_cmdList);
			}else if(deltaX==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaXN_cmdList);
			}else if(deltaY==1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaY_cmdList);
			}else if(deltaY==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaYN_cmdList);
			}else if(deltaZ==1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaZ_cmdList);
			}else if(deltaZ==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], RelativeEncodingLscape.deltaZN_cmdList);
			}else{
				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
				System.exit(-1);
			}
			
		}
		return points;
	}
	
	public static void setPoint(int[][] points, int index, char relativeEncoding, String cmdList){
		if(cmdList.length()!=5){
			System.out.println("Error cmdList.length != 5");
			System.exit(-1);
		}
		switch(relativeEncoding){
			case 'F':
				setPointByCMD(points, index, cmdList.charAt(0));
				break;
			case 'R':
				setPointByCMD(points, index, cmdList.charAt(1));
				break;
			case 'L':
				setPointByCMD(points, index, cmdList.charAt(2));
				break;
			case 'U':
				setPointByCMD(points, index, cmdList.charAt(3));
				break;
			case 'D':
				setPointByCMD(points, index, cmdList.charAt(4));
				break;
			default:
				setPointByCMD(points, index, cmdList.charAt(0));
				break;
		}
	}
	
	public static void setPointByCMD(int[][] points, int index, char cmd){
		switch(cmd){
			case 'X':
				points[index][0] = points[index-1][0]+1;
				points[index][1] = points[index-1][1];
				points[index][2] = points[index-1][2];
				break;
			case 'x':
				points[index][0] = points[index-1][0]-1;
				points[index][1] = points[index-1][1];
				points[index][2] = points[index-1][2];
				break;
			case 'Y':
				points[index][0] = points[index-1][0];
				points[index][1] = points[index-1][1]+1;
				points[index][2] = points[index-1][2];
				break;
			case 'y':
				points[index][0] = points[index-1][0];
				points[index][1] = points[index-1][1]-1;
				points[index][2] = points[index-1][2];
				break;
			case 'Z':
				points[index][0] = points[index-1][0];
				points[index][1] = points[index-1][1];
				points[index][2] = points[index-1][2]+1;
				break;
			case 'z':
				points[index][0] = points[index-1][0];
				points[index][1] = points[index-1][1];
				points[index][2] = points[index-1][2]-1;
				break;
			default:
				points[index][0] = points[index-1][0];
				points[index][1] = points[index-1][1];
				points[index][2] = points[index-1][2];
				break;
		}
	}

}
